![](assets/images/agb-broadsword.png)
# Andre' G. Bowlin
## Software Engineer / Architect / Team Lead
### Senior full stack developer with 40+ years of experience
| Contact | |
|-:|-|
| email | [agbowlin@gmail.com](mailto:agbowlin@gmail.com) |
| homepage | [liquicode.com](http://liquicode.com) |
| github | [github.com/liquicode](http://github.com/liquicode) |
# Career Summary
I discovered computer programming at the age of 14 and software development quickly became my life's passion.
		I am completely self-taught and have traversed a multitude of technical topics and circumstances over the past 40 years.
		I am continuously working on projects for paying clients as well as projects based upon my own personal interests.
		Much of my later work is publicly available as open source projects.

While my skills span across many platforms and technologies, I am very thorough when working with a new technology.
		I attempt to understand the similarities and differences between it and other comparable technologies.
		I have the depth of experience to evaluate and compare the technologies that I use.
		This allows me to provide a holistic solution to my clients which not only satisfies the technical requirements of a project but is also tailored for a client's technical and financial capacities.
		I evaluate all possible avenues for implementation and pick the one that best suits a particular client.
		There is little value in building something that is incomprehensible or unmaintainable.

After growing up with, and exclusively using, Microsoft based technologies (Win32, .NET etc.),
		I am currently focused on NodeJS and other alternative development platforms (providing me with more degrees of freedom when planning and implementing a project).
		I also host about a dozen internet servers on Linode and AWS.
		I often work alone and end up performing all functions related to a development project (requirements gathering, implementation, testing, documentation, etc.).

# Work Experience
## Architect / Lead Developer

***Omnimedia*** (*Boca Raton, FL*); from **2021-06** thru **2022-02**

Created a web based presentation system for 6-foot tall touchscreen kiosk displays.

- Developed methodologies for pushing content to specific kiosks.
- Developed a web ui to construct image based presentations and menus.
- Developed web scrapers to convert customer web sites into kiosk presentations.


## Senior Software Engineer / Architect

***Bayer CropScience*** (*St. Louis, MO*); from **2022-01** thru **2022-02**

Worked on portions of the company's R&D pipeline during a migration of legacy app functionality to a service bus architecture.

- Upgraded database structures and data from CouchDB to DynamoDB.
- Upgraded application servers from single instances (EC2) to AWS Elastic Container Service (ECS) and Fargate.
- Developed a number of small utilities to support my team such as log monitoring and data throughput analysis between pipeline nodes.
- Advised on architecture level elements of the company's overall technology pipeline.


## Architect / Lead Developer

***Early Global News (EGN)*** (*Boca Raton, FL*); from **2018-04** thru **2018-12**

Created a news gathering, curation, and publishing system for Early Global News (EGN), a daily newsletter of overnight news
			delivered to hedge funds and individual investors.

- Developed a news scraping and aggreagation system which included about 200 websites world wide.
- Developed a web ui to curate news articles, construct editions of the EGN newsletter, and publish pdf versions of the newsletter to subscribers.
- Developed the EGN website to manage subscribers and distribution lists and host newsletter archives.


## Architect / Lead Developer

***Rosen Financial, LLLP*** (*Falls Church, VA*); from **2014-06** thru **2023-08**

Worked with Rosen Financial, a financial real estate firm, to provide backoffice and technology services on a part-time basis.

- Deployed and managed the comapny's QuickBooks installation.
- Developed office SOPs and workflows.
- Developed web-based loan tracking software.
- Developed various document management applications and utilities for Windows.
- Performed various IT tasks as needed: workstation support, network configuration, backups, etc.
- Interfaced with service professionals (i.e. lawyers and accountants) to fulfill data requests.


## Architect / Lead Developer

***Smile, Inc.*** (*Lake Worth, FL*); from **2013-05** thru **2014-05**

Worked with Smile, a background screening company, to develop an online background screening service.

- Developed an AMQP message based infrastructure for scraping, compiling, and publishing public court records.
- Developed controllers to spawn and coordinate long running scraping and publishing tasks.
- Directed a small programming team to implement individualized scrapers for each US county (about 3,000)


## Senior Developer

***DrScribe*** (*Lake Worth, FL*); from **2013-01** thru **2013-04**

Worked with DrScribe, a medical services company, to integrate the DrScribe EMR application with LabCorp using HL7 messages.

- Developed interface between DrScribe and LabCorp to dispatch messages and capture results.
- Met weekly with LabCorp personnel to ensure accuracy of HL7 messages.
- Began a documentation initiative to document all DrScribe network servers, services, running tasks, and databases.


## Technology Partner

***Robertson, Anschutz, & Schneid, PL*** (*Boca Raton, FL*); from **2011-07** thru **2012-12**

RAS is a law firm in South Florida having specialties in Bankruptcy and Foreclosure processing.
						I partnered with RAS to streamline their workflows by building integration and automation systems.

- Developed BlueTrack Extensions, a suite of software solutions designed to work with and enhance the firm's case management system, BlueTrack.
				The BlueTrack software is proprietary and any enhancements had to be implemented independently and then reverse engineered into the BlueTrack system.
				The Extensions software provided advanced search features and allowed users to dynamically report on BlueTrack data.
				In an environment of rapidly changing procedures and requirements, the Extensions software saved countless companywide hours of duplicated and wasted effort.
- Led and implemented NetDirector service integration with the BlueTrack case management system.
				This integration required the development of several server side systems as well as the mapping of all data values between the NetDirector and BlueTrack systems.
				The integration automated a number of process including the intake of new referrals (Foreclosure and Bankruptcy), document requests, and 3rd party searches.
- Led and implemented a workflow system for the Foreclosure and Bankruptcy lines of business.
				The workflow system automated many routine tasks (such as performing Military and Pacer searches) and facilitated efficient inter-department collaboration through automated emails.


## Lead Developer / Architect / Manager of Development

***DJSP Enterprises, Inc.*** (*Plantation, FL*); from **2008-03** thru **2011-06**

- Performed development and maintenance of DJSP's primary case tracking application, Tracker. Implemented significant enhancements within the code to improve the overall design and re-usability of the routines. Developed a code generation mechanism and templates to provide a true data layer to the application. Implemented an auditing subsystem to track individual per-user changes to the underlying database.
- Implemented various 'intelligent' reports which provided department specific views into the Tracker database. These reports enabled users to better organize and schedule their resources in a more effective manner.
- Developed an SOA framework and network services in preparation for developing a distributed work-flow system for in-house use and to provide tighter client/vendor integration. Extensive use of GoF design patterns.
- Performed management tasks as Manager of Development including supervising developers, performing code reviews, documenting systems, constructing development, test, and stage environments, advise on infrastructure decisions, and assist in preparing for an initial audit for SOX compliance. Also developed, documented, and implemented primary SDLC processes for the company.
- Directly supported upper management and C-Level executives by performing data analysis and customized reporting.


## Software Developer

***Oasis Advantage*** (*Jupiter, FL*); from **2007-08** thru **2007-09**

- Performed reconstruction of a mission-critical database that had been damaged due to a hardware failure. Developed stored procedures to implement backup strategies for corporate databases. The stored procedures provided detailed information regarding backup and cleanup events beyond the normal SQL Server Maintenance Plans, including customized email notifications. Provided analysis and recommendations for improving access security to SQL Server. Also performed work to automate the installation and configuration of SQL Server instances.


## Software Developer

***Kaplan University*** (*Plantation, FL*); from **2007-03** thru **2007-08**

- Implemented Project 2 of 6 in Kaplan University's Financial Aid Re-engineering effort. This project automated the submission of disbursements from Kaplan to various lending agencies. This project used SFTP to upload files ELMNet and constructed Transmission Queue files for uploading via the EDconnect application.


## Owner / Developer

***Fortressgate, Inc.*** (*Beulah, MI / Boynton Beach, FL*); from **2004-03** thru **2007-03**

- Responsible for the configuration and administration of all corporate network servers and services.
- Redesigned rawtech's licensing system (v4.0). The system offers a web-based administration portal to allow software publishers, distributors, and resellers the ability to create, manage, and support their own licensing policies. A license policy allows customers to register and activate software products online. Invoices are automatically generated and delivered to distributors and publishers when a new license policy is created by a reseller. Customers are able to register and activate software products using a number of different methods: web, tcp/ip, instant messenger, email, sms, and manual via telephone.
- Assisted in the development of the software product, PowerPressed. PowerPressed functions as a MS PowerPoint Add-in to perform in-place optimizations on PowerPoint presentations. Optimizations include the removal of redundant or irrelevant information within the file as well as reducing the stored size of embedded images. Resulting presentations retain the PowerPoint format and are can be further viewed and edited by users.
- Converted the CipherBox product to the BluBox brand. CipherBox was released by Fortressgate, Inc. under the BluBox brand with no significant modifications.


## Technology Partner

***Impact Imaging, Inc.*** (*Beulah, MI*); from **2000-11** thru **2004-03**

- Design and developed a file repository networking product. The product allowed the creation of user accounts and file repository areas on the server. Accounts are given access to one or more repository areas and users may upload and download files within those areas. Network communications between the client and server are compressed and encrypted. Repositories on the server can exist as a MS SQL database, MS Access database, or as a set of files on disk. One version of the client was implemented as a Windows Explorer Namespace Extension allowing management of remote files from within Windows Explorer.
- Design and developed a video archiving, conversion, and display utility. This utility extracted frames from existing video files, performed some image processing on each frame, and stored them to a proprietary file format. The utility could also render the frames back into a standard video file format. The formats supported during both import and export of frames were the Real Media format, the Windows Media format, and the AVI format including all supported AVI codecs. A simple scripting language was developed to assist in the importing, processing, and exporting of video frames. A primitive network streaming server was also developed to stream video to the utility's video viewer.


## Software Developer

***First Union Capital Markets Group*** (*Charlotte, NC*); from **2000-04** thru **2000-11**

- Designed and developed major portions of DealMaker2, the mission-critical application for First Union National Bank's mergers and acquisitions operations. Responsible for product architecture, component development, and about 50% of the application development. DealMaker2 brings together the different levels of data processors and management staff at BHC. All users have access to real-time data while still enforcing individual security restrictions on a user's ability to view, add, edit, or delete data from the database. Flexible application-specific objects and controls were developed to expedite development and standardize DealMaker2's look and feel.


## Software Developer

***Walt Disney Imagineering*** (*Orlando, FL*); from **1999-07** thru **2000-04**

- Developed the Resource Planning application for WDI. Resource Planning is used by WDI in both Florida and California to plan for, track, and anticipate staffing requirements for current and future projects. The data (hours required per person, per project, per month) was maintained in an Essbase multidimensional database. To accommodate Mac as well as PC machines, the client application was developed using a set of predefined MS Excel 97 templates which are populated and maintained via VBA forms and code. Additional work was done to prepare for a second version of the product relying on SQL Server and VB6.


## Software Developer

***Private Individual*** (*Alexandria, VA*); from **1998** thru **1998**

- Designed and developed a relational viewer OCX for a private concern. This control is remotely based on the classic hierarchy/tree control and provides for a unique and intuitive method of displaying relational data and databases. A study and understanding of the relational paradigm and, in particular, Entity-Relationship Diagrams has been required. 


## Software Developer

***Home Automated Living, Inc.*** (*Alexandria, VA*); from **1997** thru **1997**

- Designed and developed portions of the HAL 2000 software product for Home Automated Living, Inc. HAL 2000 is a home automation product incorporating speech recognition to control home appliances and downlinks from the internet and satellite TV. Primary responsibilities included development of the Macros, Schedules, and Conditions sub-systems of the product. These sub-systems allow users to define and execute groups of commands either explicitly, at predetermined times and dates, or according to various other conditions such as sensor events and security alarms. Also developed various classes and components to facilitate an overall component-based architecture. 


## Owner / Developer

***RA-Ware Technologies, Inc.*** (*Alexandria, VA*); from **1994** thru **2004**

- Redesigned rawLicense (v3.0) to simplify the registration and activation process for end users while enhancing the management capabilities available to remote administrators. Licenses are now defined by one or more License Policies which control software usage.
- Design and developed rawLicense, a software registration and activation system designed to protect and control the public distribution of software. rawLicense uses encrypted network communications to allow users to unlock downloaded software. A branding subsystem is also incorporated into rawLicense which functions as a descriptive resource for the product and also helps to determine the type and nature of licenses available for that product. rawLicense is able to support limited term evaluation licenses as well as full retail licenses. A management utility was also developed to allow remote administrators to query the server for registration and license details. Licensing information is encoded on the user's machine and cannot be transferred to other machines. The client component also checks for date-time tampering. 
- Design and developed CipherBox, an application specializing in the compression and storage of digital images. CipherBox displays an explorer-like interface to a rawHyperStorage archive file allowing users to add, remove, and manipulate file entries within a familiar UI. Users are able to drag files into the CipherBox UI to archive them, where compression and encryption are applied according to user customizable options and a user supplied password for the archive.
- Design and developed rawHyperStorage, an archiving COM component. rawHyperStorage enables applications to archive file data, organized in a hierarchical structure, and contained within a single disk file. File data can be supplemented with application defined metadata and can be optionally compressed and encrypted within the archive. The component models a file system within the archive, allowing applications to manipulate folders and file entries within the archive file. This project used 64-bit file pointers allowing archive files to exceed the 2GB file limitation. Each file entry is encoded independently and an index is kept to facilitate random access of file entries. All internal indices and data are also encrypted within the archive file. 
- Design and developed CryptLib, a COM component implementing various encryption algorithms. Options are available to compress as well as encrypt network traffic using Zlib for binary compression and the Blowfish, TEA, XOR, or DES algorithms for encryption.
- Design and developed rawNet, a networking COM component. Options are available to compress as well as encrypt network traffic using Zlib for binary compression and the Blowfish algorithm for encryption.
- Designed and developed the Creator's ToolKit product for RA-Ware Technologies, Inc. This product is a set of COM components designed to facilitate the development of advanced and flexible user interfaces. This product encapsulates certain functionality (i.e. Styles, FmtText, Images, Borders, etc.) that can be used and manipulated from within an application or custom controls. A surface object is also provided to allow implementation of double-buffered animation and flicker-free drawing. VB5 product demos include a bitmap button, listbox, grid, scrolling marquee, and various other useful controls.
- Converted the List Collection controls to support the 16 and 32-bit OCX component standard. Development required an extensive and intimate knowledge of MFC and OLE programming. Project highlights include: Centralization of primary objects into a single DLL which are shared among the rest of the controls; Customized notification mechanisms allow immediate updates of displayable controls in response to changes in underlying List and Item objects; Implementation of dual (IDispatch and custom) interfaces for all objects and controls provides for type-safe programming by the user and increased performance benefits; A component-based development strategy was implemented which resulted in reducing the required changes for maintenance of the List Collection controls and allowing the same set of source code to generate identical 16 and 32-bit OCXs. These controls and objects also offered the highest levels of speed and storage capacity available on the market at the time of their release.
- Designed and developed the List Collection, a package of nine listbox-type VBX custom controls for use with Visual Basic and other VBX compatible development environments. All of the controls were written from scratch and without subclassing other controls. Through the use formatting codes and special properties, the List Collection places an emphasis on the use of color, images, and a customizable interface. The controls all implement a virtual memory subsystem, which allow applications to access up to 500 megabytes of memory for storage of text, images, and other resources in 16bit environments.


## Software Developer

***National Credit Union Administration*** (*Washington, DC*); from **1991** thru **1995**

- Designed and developed the Loan Analysis module for AIRES, the primary tool used by the National Credit Union Administration's Examiner and Auditing staff. This module allows extensive analysis of loans made by credit unions and the factors contributing to the loan granting process. The software is designed to be flexible enough to group and classify concentrations of credit granted to different members of the same family or household. To support a wide variety of changing standards and circumstances, an integrated query and grouping system was developed which allow loans to be queried and then referenced within user-defined groups. This feature was also used to facilitate a Team Exam, wherein different members of a team work separately on the same database, requiring changes to be compiled into one final database. The Loan Analysis module was written in Visual Basic for Windows. 
- Design and developed an application for the Financial Crimes Enforcement Network (a joint effort of the FRB, OCC, RTC, OTS, FDIC, and NCUA) to collect and validate data concerning known and/or suspected financial crimes. The application is a data-entry system to be used by all of the financial institutions in the United States. Data collected at the financial institutions is transmitted to a main database accessed by all of the financial regulatory agencies. The lifetime of the data is designed to be error-free and secure. At the completion of the data-entry process, an OCR scannable printout is generated and sent to FinCEN for scanning and eventually stored on a shared network. A class framework was developed in C++ for the DOS environment which allowed for popup windows, listboxes, textboxes, and display labels. Support for decorative frames and colorful text display was also integrated into this framework. 
- Design and developed a utility for the National Credit Union Administration to freely convert data between various major data based applications including Lotus 1-2-3, DBase III-IV, and Microsoft Excel for Windows. The development of this utility required the reverse engineering of file formats for several of these applications. Received recognition for exceptional performance and initiative. 
- Design and developed a system level application to help synchronize updates between master databases residing on a Tandem mainframe and SQL databases residing on the NCUA Headquarters' LAN and Regional servers. Updates made by users across the country to the master database are interpreted and mapped to the structure of the SQL databases, allowing an update operation to proceed. In order to ensure data integrity, this project required the implementation of extensive error-recovery and backup systems to be incorporated into the utility. 
- Design and developed an employee evaluation system for the National Credit Union Administration for use by NCUA supervisors and managers across the United States. The flexible and robust design of this system was so successful that end-users began to using it for their own analysis and reporting needs. Received recognition for outstanding program and interface design. 


## Software Developer

***Lombardi Cancer Research Center*** (*Washington, DC*); from **1994** thru **1994**

- Contracted with the Lombardi Cancer Research Center at Georgetown University to redesign an in-house database and data entry system for use in a long-term cancer research study. The resulting application was required to be compatible with an in-place reporting system. Primary responsibilities included incorporating export and reporting features into the program and also to programmatically scan import and key-input data for duplication and possible miskeying. As the criteria for duplication was based on an "educated guess" by comparing a person's name, birth date, and other prioritized values, a significant amount of attention was given to optimizing Visual Basic's Data Access database operations. 


## Software Developer

***Bitstreams, Inc.*** (*Washington, DC*); from **1993** thru **1993**

- Designed and developed the software product Bit Talk for Windows, for Bitstreams, Inc. Bit Talk is a front-end user interface for remote mainframe and PC FOCUS databases. The employment of this product effectively overcomes severe limitations posed by many commercial mainframe based applications. 


## Software Developer

***The NetWeave Corporation*** (*Philadelphia, PA*); from **1992** thru **1992**

- Converted pre-existing C code library for The NetWeave Corporation's principal software product, NetWeave, into a Windows compatible DLL for use with Visual Basic. NetWeave is a software library designed to facilitate client-server communications between various major mainframes and personal computers. This project required considerable analysis of the Microsoft Windows communications subsystem, memory management, and addressing. Requirements also included the modification of more than 750,000 lines of C code to operate safely in Windows. 


## Software Developer

***Sales and Marketing Systems, Inc.*** (*Fairfax, VA*); from **1991** thru **1992**

- Converted Sales and Marketing Systems' primary product, SalesCtrl2 (a sales tracking and lead management software product), to be compatible with several major external word processing packages (MS Word, WordPerfect, and WordStar). The conversion of SalesCtrl2 required the modification and management of over 250,000 lines of C code. Also developed a utility application for end-users of SalesCtrl2 to convert documents between these word processing packages and SalesCtrl2's native file format. The completion of this project included reverse engineering of each of the major word processor's file formats. 


## Software Developer

***The World Bank*** (*Dhaka, Bangladesh*); from **1983** thru **1983**

- Developed financial analysis and reporting package of World Bank projects for World Bank executive management. Consulted with Bank and local project managers on reporting and application requirements. Conducted the development of end-user documentation and training. 


# Skills & Tools
## Platforms
| | |
|-:|-|
| Windows | ████████── |
| Linux | ███████─── |
| AWS | ████████── |
## Languages
| | |
|-:|-|
| Javascript (NodeJS) | █████████─ |
| Javascript (Browser) | ████████── |
| .NET2-4 | █████████─ |
| .NET5+ | ███████─── |
| PHP | ██████──── |
| Python | ██████──── |
| Java | ████────── |
| C# | █████████─ |
| C/C++ | ████████── |
| VisualBasic | █████████─ |
| Pascal | █████████─ |
| HTML/CSS | ███████── |
## Tools
| | |
|-:|-|
| VSCode | █████████─ |
| MS Excel | █████████─ |
| MS Visual Studio | ████████── |
| ExpressJS | ████████── |
| Apache | ███████─── |
| Nginx | ████████── |
| Wordpress | ███████─── |
## Databases
| | |
|-:|-|
| MongoDB | █████████─ |
| MySql | ████████── |
| MS SqlServer | ███████─── |
## Technologies
| | |
|-:|-|
| AngularJS | ████████── |
| Networking (TCP/IP) | █████████─ |
| Message Queues (AMQP) | █████████─ |
| Hardware Virtualization | ███████─── |
| Encryption/Security | ████████── |

